# A pipeline is composed of independent jobs that run scripts, grouped into stages.
# Stages run in sequential order, but jobs within stages run in parallel.
#
# For more information, see: https://docs.gitlab.com/ee/ci/yaml/index.html#stages

stages:          # List of stages for jobs, and their order of execution
  - build
# - test
# - deploy

build-job:       # This job runs in the build stage, which runs first.
  stage: build
  script:
    - echo "Installing Lazarus..."
    - apt update && apt install -y lazarus
    - echo "Installation complete."
    - echo "Compiling the code..."
    - lazbuild sudoctor2.lpi
    - echo "Compile complete."
  artifacts:
    paths:
      - "sudoctor2"
  cache:
    paths:
      - "*.o"
      - "*.ppu"
      - "*.compiled"
      - "*.lrs"
      - "*.rc"


#unit-test-job:   # This job runs in the test stage.
#  stage: test    # It only starts when the job in the build stage completes successfully.
#  script:
#    - echo "Running unit tests... This will take about 60 seconds."
#    - sleep 60
#    - echo "Code coverage is 90%"

#lint-test-job:   # This job also runs in the test stage.
#  stage: test    # It can run at the same time as unit-test-job (in parallel).
#  script:
#    - echo "Linting code... This will take about 10 seconds."
#    - sleep 10
#    - echo "No lint issues found."

#deploy-job:      # This job runs in the deploy stage.
#  stage: deploy  # It only runs when *both* jobs in the test stage complete successfully.
#  script:
#    - echo "Deploying application..."
#    - echo "Application successfully deployed."
